## ns3 3.41

=== ns-3.41/CMakeLists.txt ===
# ##############################################################################
# Required CMake version            #
# ##############################################################################
cmake_minimum_required(VERSION 3.13..3.13)

# ##############################################################################
# Project name                        #
# ##############################################################################
project(NS3 CXX C)

file(STRINGS VERSION NS3_VER)

# minimum compiler versions
set(AppleClang_MinVersion 11.0.0)
set(Clang_MinVersion 10.0.0)
set(GNU_MinVersion 9.0.0)

# common options
option(NS3_ASSERT "Enable assert on failure" OFF)
option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
option(NS3_EXAMPLES "Enable examples to be built" OFF)
option(NS3_LOG "Enable logging to be built" OFF)
option(NS3_TESTS "Enable tests to be built" OFF)

# fd-net-device options
option(NS3_EMU "Build with emulation support" ON)
option(NS3_TAP "Build with Tap support" ON)
option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)

# maintenance and documentation
option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
option(NS3_CLANG_TIMETRACE
       "Collect compilation statistics to analyze the build process" OFF
)
option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
option(NS3_COVERAGE "Enable code coverage measurements and report generation"
       OFF
)
option(NS3_COVERAGE_ZERO_COUNTERS
       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
)
option(NS3_INCLUDE_WHAT_YOU_USE
       "Use IWYU to determine unnecessary headers included" OFF
)
option(NS3_LINK_WHAT_YOU_USE
       "Use LWYU to determine unnecessary linked libraries" OFF
)
option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)

# 3rd-party libraries/programs
option(NS3_NETANIM "Build netanim" OFF)

# other options
option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
option(NS3_CPM "Enable the CPM C++ library manager support" OFF)
option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
option(NS3_FETCH_OPTIONAL_COMPONENTS
       "Fetch Brite, Click and Openflow dependencies" OFF
)
option(NS3_GSL "Build with GSL support" ON)
option(NS3_GTK3 "Build with GTK3 support" ON)
option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
option(NS3_MONOLIB
       "Build a single shared ns-3 library and link it against executables" OFF
)
option(NS3_MPI "Build with MPI support" OFF)
option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
option(
  NS3_NINJA_TRACING
  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
  OFF
)
set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
option(NS3_PRECOMPILE_HEADERS
       "Precompile module headers to speed up compilation" ON
)
option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
option(NS3_SQLITE "Build with SQLite support" ON)
option(NS3_EIGEN "Build with Eigen support" ON)
option(NS3_STATIC "Build a static ns-3 library and link it against executables"
       OFF
)
option(NS3_VCPKG "Enable the Vcpkg C++ library manager support" OFF)
option(NS3_VERBOSE "Print additional build system messages" OFF)
option(NS3_VISUALIZER "Build visualizer module" ON)
option(NS3_WARNINGS "Enable compiler warnings" ON)
option(NS3_WARNINGS_AS_ERRORS
       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
)

# Options that either select which modules will get built or disable modules
set(NS3_ENABLED_MODULES ""
    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
)
set(NS3_DISABLED_MODULES "" CACHE STRING
                                  "List of modules to disable (e.g. lte;wimax)"
)

# Filter in the modules from which examples and tests will be built
set(NS3_FILTER_MODULE_EXAMPLES_AND_TESTS
    ""
    CACHE
      STRING
      "List of modules that should have their examples and tests built (e.g. lte;wifi)"
)

if(${NS3_CCACHE})
  # Use ccache if available
  mark_as_advanced(CCACHE)
  find_program(CCACHE ccache)
  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
    message(STATUS "CCache is enabled.")
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    execute_process(
      COMMAND
        ${CCACHE} --set-config
        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
    )
  endif()
endif()

# Include macros used below
include(build-support/macros-and-definitions.cmake)

# Scan module libraries
subdirlist(libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/src)

# Scan contribution libraries
subdirlist(contrib_libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/contrib)

# Before filtering, we need to load settings from .ns3rc
parse_ns3rc(
  ns3rc_enabled_modules ns3rc_disabled_modules ns3rc_examples_enabled
  ns3rc_tests_enabled
)

# After scanning modules, we can filter enabled and disabled ones
filter_enabled_and_disabled_modules(
  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
  ns3rc_enabled_modules ns3rc_disabled_modules
)

# ##############################################################################
# Process options                     #
# ##############################################################################
process_options()

# ##############################################################################
# Add subdirectories                  #
# ##############################################################################
# Build NS3 library core
add_subdirectory(src)

# Build NS library examples
add_subdirectory(examples)

# Build scratch/simulation scripts
add_subdirectory(scratch)

# Build test utils
add_subdirectory(utils)

write_lock()
write_configtable()

# Export package targets when installing
ns3_cmake_package()

=== ns-3.41/src/CMakeLists.txt ===
set(libs "${libs_to_build}")

# Process the visualizer module first if enabled
if(visualizer IN_LIST libs)
  if(${ENABLE_VISUALIZER})
    message(STATUS "Processing src/visualizer")
    add_subdirectory(visualizer)
  endif()
  list(REMOVE_ITEM libs visualizer)
endif()

# Process subdirectories
foreach(libname ${libs})
  if(EXISTS ${PROJECT_SOURCE_DIR}/src/${libname}/CMakeLists.txt)
    message(STATUS "Processing src/${libname}")
    add_subdirectory(${libname})
  else()
    message(${HIGHLIGHTED_STATUS}
            "Skipping src/${libname}: it does not contain a CMakeLists.txt file"
    )
  endif()
endforeach()

# Prevents link errors due to symbol collisions if the same library is linked
# multiple times
list(REMOVE_DUPLICATES ns3-external-libs)

# Build the lib-ns3-static (ns3.x-static-buildtype.a/.lib) with all sublibraries
if(${NS3_STATIC})
  add_library(
    ${lib-ns3-static} STATIC ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                             "${lib-ns3-static-objs}"
  )

  # Replace shared library suffix and check if static version exists before
  # linking
  set(ns3-external-static-libs)
  foreach(sharedlib ${ns3-external-libs})
    if(NOT (${sharedlib} MATCHES ".so"))
      list(APPEND ns3-external-static-libs ${sharedlib})
      continue()
    endif()

    string(REPLACE ".so" ".a" output ${sharedlib})
    if(EXISTS ${output})
      list(APPEND ns3-external-static-libs ${output})
    else()
      message(
        FATAL_ERROR "Static library version of ${sharedlib} was not found"
      )
    endif()
  endforeach()

  # Required by some static libraries, such as sqlite, for some odd reason
  if(LINUX)
    list(APPEND ns3-external-static-libs -ldl)
  endif()

  target_link_libraries(
    ${lib-ns3-static} ${STATIC_LINK_FLAGS} ${LIB_AS_NEEDED_PRE_STATIC}
    ${ns3-external-static-libs} ${LIB_AS_NEEDED_POST_STATIC}
  )
  if(${NS3_CLANG_TIMETRACE})
    add_dependencies(timeTraceReport ${lib-ns3-static})
  endif()
endif()

# Build the lib-ns3 (ns3.x-monolib-buildtype.dll/.dylib/.so) with all
# sublibraries
if(${NS3_MONOLIB})
  add_library(
    ${lib-ns3-monolib} SHARED ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                              "${lib-ns3-static-objs}"
  )
  set_target_properties(
    ${lib-ns3-monolib}
    PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE
               RUNTIME_OUTPUT_DIRECTORY
               ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} # set output directory for DLLs
  )
  target_link_libraries(
    ${lib-ns3-monolib} ${LIB_AS_NEEDED_PRE} ${ns3-external-libs}
    ${LIB_AS_NEEDED_POST}
  )
  if(${NS3_CLANG_TIMETRACE})
    add_dependencies(timeTraceReport ${lib-ns3-monolib})
  endif()
endif()

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  add_dependency_to_optional_modules_dependencies()
endif()

=== ns-3.41/utils/CMakeLists.txt ===
if(${ENABLE_TESTS})
  set(test_sources)
  if(test IN_LIST libs_to_build)
    # Create a list of imported directories to include during libtest build
    set(test_imported_include_directories)
    foreach(libname ${ns3-libs} ${ns3-contrib-libs})
      list(APPEND test_imported_include_directories $<TARGET_PROPERTY:${libname},INTERFACE_INCLUDE_DIRECTORIES>)
    endforeach()

    # Import include directories of dependencies to build libtest
    target_include_directories(${libtest} PUBLIC ${test_imported_include_directories})
    unset(test_imported_include_directories)

    # Define the libtest as an object to build test-runner
    set(test_sources $<TARGET_OBJECTS:${libtest}>)
  endif()

  if(WIN32)
    # DLL linking shenanigans prevent loading symbols unused by a certain program,
    # so link the tests libraries (here built as objects) directly to the test runner
    add_executable(test-runner test-runner.cc ${ns3-libs-tests} ${test_sources})
    if(${NS3_MONOLIB})
      target_link_libraries(
              test-runner ${lib-ns3-monolib} ${ns3-contrib-libs}
      )
    else()
      target_link_libraries(
              test-runner ${ns3-libs} ${ns3-contrib-libs}
      )
    endif()
  else()
    add_executable(test-runner ${test_sources} test-runner.cc)

    if(${NS3_MONOLIB})
      target_link_libraries(
        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${lib-ns3-monolib} ${ns3-contrib-libs} ${LIB_AS_NEEDED_POST}
      )
    else()
      target_link_libraries(
        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${ns3-libs} ${ns3-contrib-libs} ${LIB_AS_NEEDED_POST}
      )
    endif()
  endif()
  set_runtime_outputdirectory(
    test-runner ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utils/ ""
  )
  add_dependencies(test-runner test-runner-examples-as-tests)
  add_dependencies(all-test-targets test-runner)
endif()

build_exec(
        EXECNAME bench-scheduler
        SOURCE_FILES bench-scheduler.cc
        LIBRARIES_TO_LINK ${libcore}
        EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utils/
      )

if(network IN_LIST libs_to_build)
  build_exec(
        EXECNAME bench-packets
        SOURCE_FILES bench-packets.cc
        LIBRARIES_TO_LINK ${libnetwork}
        EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utils/
      )

  build_exec(
      EXECNAME print-introspected-doxygen
      SOURCE_FILES print-introspected-doxygen.cc
      LIBRARIES_TO_LINK ${ns3-libs} ${ns3-contrib-libs}
      EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utils/
    )
endif()

if(core IN_LIST ns3-all-enabled-modules)
  build_exec(
    EXECNAME perf-io
    SOURCE_FILES perf/perf-io.cc
    LIBRARIES_TO_LINK ${libcore}
    EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utils/perf/
  )
endif()

=== ns-3.41/doc/contributing/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

# Additional variables for figures, not sphinx default:
DIA = dia
EPSTOPDF = epstopdf
FIGURES = source/figures
IMAGES_EPS = \

IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

.NOTPARALLEL:

%.eps : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t eps $< -e $@ >/dev/null

%.png : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t png $< -e $@ >/dev/null

%.png : %.eps
	@echo convert $(notdir $<)
	@$(CONVERT) $< $@ >/dev/null

%.pdf : %.eps
	@echo epstopdf $(notdir $<)
	@$(EPSTOPDF) $< -o=$@ >/dev/null
	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)

frag: pickle
	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag

html: $(IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: $(IMAGES)
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: $(IMAGES)
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: $(IMAGES)
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: $(IMAGES)
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: $(IMAGES)
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: $(IMAGES)
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"

devhelp: $(IMAGES)
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
	@echo "# devhelp"

epub: $(IMAGES)
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: $(IMAGES)
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: $(IMAGES)
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: $(IMAGES)
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: $(IMAGEs)
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: $(IMAGES)
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== ns-3.41/doc/manual/Makefile ===
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures
#VPATH = $(FIGURES)

# list all manual .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/attributes.rst \
	source/callbacks.rst \
	source/develop.rst \
	source/documentation.rst \
	source/enable-modules.rst \
	source/enable-tests.rst \
	source/events.rst \
	source/features.rst \
	source/gnuplot.rst \
	source/hash-functions.rst \
	source/helpers.rst \
	source/how-to-write-tests.rst \
	source/logging-asserts.rst \
	source/new-models.rst \
	source/new-modules.rst \
	source/object-model.rst \
	source/object-names.rst \
	source/organization.rst \
	source/profiling.rst \
	source/python.rst \
	source/random-variables.rst \
	source/realtime.rst \
	source/simulator.rst \
	source/support.rst \
	source/test-background.rst \
	source/test-framework.rst \
	source/test-overview.rst \
	source/tests.rst \
	source/tracing.rst \
	source/troubleshoot.rst \
	source/utilities.rst \
	source/working-with-cmake.rst \
	source/working-with-git.rst \
	source/working-with-gitlab-ci-local.rst \
	${SRC}/stats/doc/data-collection.rst \
	${SRC}/stats/doc/data-collection-overview.rst \
	${SRC}/stats/doc/statistics.rst \
	${SRC}/stats/doc/data-collection-helpers.rst \
	${SRC}/stats/doc/probe.rst \
	${SRC}/stats/doc/collector.rst \
	${SRC}/stats/doc/aggregator.rst \
	${SRC}/stats/doc/adaptor.rst \
	${SRC}/stats/doc/scope-and-limitations.rst \

# list all manual figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) both a .pdf and .png file

SOURCEFIGS = \
    figures/software-organization.dia \
	figures/plot-2d.png \
	figures/plot-2d-with-error-bars.png \
	figures/plot-3d.png \
	figures/gtk-config-lena-dual-stripe-device-view.png \
	figures/gtk-config-lena-dual-stripe-eNB-tx-power.png \
	figures/heaptrack.png \
	figures/hotspot-cycles.png \
	figures/hotspot-setup.png \
	figures/hotspot-top-down.png \
	figures/perfetto-trace-cmake.png \
	figures/time-consuming-event-handling.png \
	figures/uprof-collect-callstack.png \
	figures/uprof-profile-application.png \
	figures/uprof-select-events.png \
	figures/uprof-start.png \
	figures/uprof-stats.png \
	figures/uprof-strace-lte.png \
	figures/vtune-configure.png \
	figures/vtune-landing.png \
	figures/vtune-perf-snapshot.png \
	figures/vtune-select-uarch-profiling.png \
	figures/vtune-uarch-core-stats.png \
	figures/vtune-uarch-profiling-summary.png \
	figures/vtune-uarch-wifi-stats.png \
	${SRC}/stats/doc/Stat-framework-arch.png \
	${SRC}/stats/doc/Wifi-default.png \
	${SRC}/stats/doc/dcf-overview.dia \
	${SRC}/stats/doc/dcf-overview-with-aggregation.dia \
	${SRC}/stats/doc/seventh-packet-byte-count.png \
	${SRC}/stats/doc/gnuplot-helper-example.png \
	${SRC}/stats/doc/gnuplot-aggregator.png \

# specify figures from which .png and .pdf figures need to be
# generated (all dia and eps figures)
IMAGES_EPS = \
	$(FIGURES)/software-organization.eps \
	$(FIGURES)/dcf-overview.eps \
	$(FIGURES)/dcf-overview-with-aggregation.eps \

# rescale pdf figures as necessary
$(FIGURES)/software-organization.pdf_width = 5in

IMAGES_PNG = $(IMAGES_EPS:.eps=.png)

IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

RESCALE = ../../utils/rescale-pdf.sh

%.eps : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t eps $< -e $@ >/dev/null

%.png : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t png $< -e $@ >/dev/null

%.png : %.eps
	@echo convert $(notdir $<)
	@$(CONVERT) $< $@ >/dev/null

%.pdf : %.eps
	@echo epstopdf $(notdir $<)
	@$(EPSTOPDF) $< -o=$@ >/dev/null
	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCETEMP)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

.NOTPARALLEL:

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

copy-sources:  $(SOURCES)
	@rm -rf $(SOURCETEMP)
	@mkdir -p $(SOURCETEMP)
	@mkdir -p $(FIGURES)
	@cp -r $(SOURCES) $(SOURCETEMP)
	@cp -r $(SOURCEFIGS) $(FIGURES)

clean:
	-rm -rf $(BUILDDIR)
	-rm -rf $(SOURCETEMP)

frag: pickle
	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag

html: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"

devhelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
	@echo "# devhelp"

epub: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."


test: $(IMAGES)

=== ns-3.41/doc/models/Makefile ===
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures

# list all model library .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/organization.rst \
	source/internet-models.rst \
	source/network.rst \
	source/emulation-overview.rst \
	source/traffic-control.rst \
	$(SRC)/antenna/doc/source/antenna.rst \
	$(SRC)/antenna/doc/source/antenna-design.rst \
	$(SRC)/antenna/doc/source/antenna-user.rst \
	$(SRC)/antenna/doc/source/antenna-testing.rst \
	$(SRC)/aodv/doc/aodv.rst \
	$(SRC)/applications/doc/applications.rst \
	$(SRC)/bridge/doc/bridge.rst \
	$(SRC)/brite/doc/brite.rst \
	$(SRC)/buildings/doc/source/buildings.rst \
	$(SRC)/buildings/doc/source/buildings-design.rst \
	$(SRC)/buildings/doc/source/buildings-user.rst \
	$(SRC)/buildings/doc/source/buildings-testing.rst \
	$(SRC)/buildings/doc/source/buildings-references.rst \
	$(SRC)/click/doc/click.rst \
	$(SRC)/csma/doc/csma.rst \
	$(SRC)/dsdv/doc/dsdv.rst \
	$(SRC)/dsr/doc/dsr.rst \
	$(SRC)/mpi/doc/distributed.rst \
	$(SRC)/energy/doc/energy.rst \
	$(SRC)/fd-net-device/doc/fd-net-device.rst \
	$(SRC)/fd-net-device/doc/dpdk-net-device.rst \
	$(SRC)/fd-net-device/doc/netmap-net-device.rst \
	$(SRC)/tap-bridge/doc/tap.rst \
	$(SRC)/mesh/doc/source/mesh.rst \
	$(SRC)/mesh/doc/source/mesh-user.rst \
	$(SRC)/mesh/doc/source/mesh-design.rst \
	$(SRC)/mesh/doc/source/mesh-references.rst \
	$(SRC)/mesh/doc/source/mesh-testing.rst \
	$(SRC)/lte/doc/source/lte.rst \
	$(SRC)/lte/doc/source/lte-user.rst \
	$(SRC)/lte/doc/source/lte-design.rst \
	$(SRC)/lte/doc/source/lte-testing.rst \
	$(SRC)/lte/doc/source/lte-profiling.rst \
	$(SRC)/lte/doc/source/lte-references.rst \
	$(SRC)/propagation/doc/propagation.rst \
	$(SRC)/network/doc/network-overview.rst \
	$(SRC)/network/doc/packets.rst \
	$(SRC)/network/doc/error-model.rst \
	$(SRC)/network/doc/sockets-api.rst \
	$(SRC)/network/doc/simple.rst \
	$(SRC)/network/doc/queue.rst \
	$(SRC)/network/doc/queue-limits.rst \
	$(SRC)/nix-vector-routing/doc/nix-vector-routing.rst \
	$(SRC)/internet/doc/internet-stack.rst \
	$(SRC)/internet/doc/ipv4.rst \
	$(SRC)/internet/doc/ipv6.rst \
	$(SRC)/internet/doc/routing-overview.rst \
	$(SRC)/internet/doc/tcp.rst \
	$(SRC)/internet/doc/udp.rst \
	$(SRC)/internet-apps/doc/internet-apps.rst \
	$(SRC)/mobility/doc/mobility.rst \
	$(SRC)/olsr/doc/olsr.rst \
	$(SRC)/openflow/doc/openflow-switch.rst \
	$(SRC)/point-to-point/doc/point-to-point.rst \
	$(SRC)/wifi/doc/source/wifi.rst \
	$(SRC)/wifi/doc/source/wifi-design.rst \
	$(SRC)/wifi/doc/source/wifi-user.rst \
	$(SRC)/wifi/doc/source/wifi-testing.rst \
	$(SRC)/wifi/doc/source/wifi-changelog.rst \
	$(SRC)/wifi/doc/source/wifi-references.rst \
	$(SRC)/wimax/doc/wimax.rst \
	$(SRC)/uan/doc/uan.rst \
	$(SRC)/topology-read/doc/topology.rst \
	$(SRC)/traffic-control/doc/traffic-control-layer.rst \
	$(SRC)/traffic-control/doc/queue-discs.rst \
	$(SRC)/traffic-control/doc/pfifo-fast.rst \
	$(SRC)/traffic-control/doc/fifo.rst \
	$(SRC)/traffic-control/doc/prio.rst \
	$(SRC)/traffic-control/doc/tbf.rst \
	$(SRC)/traffic-control/doc/red.rst \
	$(SRC)/traffic-control/doc/codel.rst \
	$(SRC)/traffic-control/doc/cobalt.rst \
	$(SRC)/traffic-control/doc/fq-codel.rst \
	$(SRC)/traffic-control/doc/fq-cobalt.rst \
	$(SRC)/traffic-control/doc/pie.rst \
	$(SRC)/traffic-control/doc/fq-pie.rst \
	$(SRC)/traffic-control/doc/mq.rst \
	$(SRC)/spectrum/doc/spectrum.rst \
	$(SRC)/netanim/doc/animation.rst \
	$(SRC)/flow-monitor/doc/flow-monitor.rst \
	$(SRC)/sixlowpan/doc/sixlowpan.rst \
	$(SRC)/lr-wpan/doc/lr-wpan.rst \

# list all model library figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) both a .pdf and .png file
SOURCEFIGS = \
	figures/testbed.dia \
	figures/emulated-channel.dia \
	$(SRC)/antenna/doc/source/figures/antenna-coordinate-system.dia	\
	$(SRC)/applications/doc/http-embedded-object-size.png \
	$(SRC)/applications/doc/http-main-object-size.png \
	$(SRC)/applications/doc/http-num-of-embedded-objects.png \
	$(SRC)/applications/doc/http-parsing-time.png \
	$(SRC)/applications/doc/http-reading-time.png \
	$(SRC)/network/doc/packet.dia \
	$(SRC)/network/doc/node.dia \
	$(SRC)/network/doc/buffer.dia \
	$(SRC)/network/doc/sockets-overview.dia \
	$(SRC)/internet/doc/internet-node-send.dia \
	$(SRC)/internet/doc/internet-node-recv.dia \
	$(SRC)/internet/doc/routing.dia \
	$(SRC)/internet/doc/routing-specialization.dia \
	$(SRC)/internet/doc/figures/tcp-state-machine.png \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-new-reno.png \
	$(SRC)/internet/doc/figures/ns3-new-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/ns3-bbr-vs-linux-bbr.png \
	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/snir.dia \
	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
	$(SRC)/wifi/doc/source/figures/assoc-manager.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-dl-txop.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-ul-txop.eps \
	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/mu-bar.png \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.png \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.pdf \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.png \
	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ac.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ax.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11a-p-1500-adhoc-r-54-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/default-table-based-error-model-validation.eps \
	$(SRC)/wifi/doc/source/figures/error-models-comparison.eps \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.png \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.png \
	$(SRC)/wimax/doc/WimaxArchitecture.dia \
	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/epc-topology.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-x2-enhanced.dia \
	$(SRC)/lte/doc/source/figures/eutran-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/ff-example.dia \
	$(SRC)/lte/doc/source/figures/ff-mac-saps.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-enb-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-ue-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-handover-seq-diagram.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-control-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-interference-test-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-subframe-structure.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-interface.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-architecture.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-processes-scheme.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-consumer.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-motion.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1-hys.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-timeline.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-handover-target-scenario.dia \
	$(SRC)/lte/doc/source/figures/lena-dual-stripe.eps \
	$(SRC)/lte/doc/source/figures/lte-mcs-index.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase1.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase2.eps \
	$(SRC)/lte/doc/source/figures/runningTime10s.eps \
	$(SRC)/lte/doc/source/figures/epcRunningTime.eps \
	$(SRC)/lte/doc/source/figures/propagationModel.eps \
	$(SRC)/lte/doc/source/figures/simulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcSimulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcEutranRunningTime.eps \
	$(SRC)/lte/doc/source/figures/profiling-memory.eps \
	$(SRC)/lte/doc/source/figures/lte-rlc-implementation-model.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-entity-saps.dia \
	$(SRC)/lte/doc/source/figures/ca-rrc-reconf.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-enb-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-ue-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/lte-strongest-cell-handover-algorithm.eps \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.pdf \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.png \
	$(SRC)/lte/doc/source/figures/helpers.pdf \
	$(SRC)/lte/doc/source/figures/helpers.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration-handover.pdf \

=== ns-3.41/examples/routing/CMakeLists.txt ===
build_example(
  NAME dynamic-global-routing
  SOURCE_FILES dynamic-global-routing.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libcsma}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME static-routing-slash32
  SOURCE_FILES static-routing-slash32.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libcsma}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME global-routing-slash32
  SOURCE_FILES global-routing-slash32.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libcsma}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME global-injection-slash32
  SOURCE_FILES global-injection-slash32.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libcsma}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME simple-global-routing
  SOURCE_FILES simple-global-routing.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libflow-monitor}
)

build_example(
  NAME simple-alternate-routing
  SOURCE_FILES simple-alternate-routing.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME mixed-global-routing
  SOURCE_FILES mixed-global-routing.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libcsma}
    ${libapplications}
)

build_example(
  NAME simple-routing-ping6
  SOURCE_FILES simple-routing-ping6.cc
  LIBRARIES_TO_LINK
    ${libcsma}
    ${libinternet}
    ${libinternet-apps}
)

build_example(
  NAME manet-routing-compare
  SOURCE_FILES manet-routing-compare.cc
  LIBRARIES_TO_LINK
    ${libwifi}
    ${libdsr}
    ${libdsdv}
    ${libaodv}
    ${libolsr}
    ${libinternet}
    ${libapplications}
    ${libflow-monitor}
)

build_example(
  NAME ripng-simple-network
  SOURCE_FILES ripng-simple-network.cc
  LIBRARIES_TO_LINK
    ${libcsma}
    ${libinternet}
    ${libinternet-apps}
)

build_example(
  NAME rip-simple-network
  SOURCE_FILES rip-simple-network.cc
  LIBRARIES_TO_LINK
    ${libcsma}
    ${libinternet}
    ${libinternet-apps}
)

build_example(
  NAME global-routing-multi-switch-plus-router
  SOURCE_FILES global-routing-multi-switch-plus-router.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${libapplications}
    ${libinternet}
    ${libbridge}
    ${libcsma}
    ${libpoint-to-point}
    ${libcsma}
    ${libinternet}
)

build_example(
  NAME simple-multicast-flooding
  SOURCE_FILES simple-multicast-flooding.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${libapplications}
    ${libinternet}
)

=== ns-3.41/examples/socket/CMakeLists.txt ===
build_example(
  NAME socket-bound-static-routing
  SOURCE_FILES socket-bound-static-routing.cc
  LIBRARIES_TO_LINK
    ${libnetwork}
    ${libcsma}
    ${libpoint-to-point}
    ${libinternet}
)

build_example(
  NAME socket-bound-tcp-static-routing
  SOURCE_FILES socket-bound-tcp-static-routing.cc
  LIBRARIES_TO_LINK
    ${libnetwork}
    ${libcsma}
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
)

build_example(
  NAME socket-options-ipv4
  SOURCE_FILES socket-options-ipv4.cc
  LIBRARIES_TO_LINK
    ${libnetwork}
    ${libcsma}
    ${libpoint-to-point}
    ${libinternet}
)

build_example(
  NAME socket-options-ipv6
  SOURCE_FILES socket-options-ipv6.cc
  LIBRARIES_TO_LINK
    ${libnetwork}
    ${libcsma}
    ${libpoint-to-point}
    ${libinternet}
)

=== ns-3.41/src/core/CMakeLists.txt ===
# Set lib core link dependencies
set(libraries_to_link)

set(gsl_test_sources)
if(${GSL_FOUND})
  set(libraries_to_link
      ${libraries_to_link}
      ${GSL_LIBRARIES}
  )
  set(gsl_test_sources
      test/rng-test-suite.cc
      test/random-variable-stream-test-suite.cc
  )
endif()

# Check for dependencies and add sources accordingly
check_include_files(
  "boost/units/quantity.hpp;boost/units/systems/si.hpp"
  HAVE_BOOST_UNITS
  LANGUAGE
  CXX
)

if(${HAVE_BOOST_UNITS})
  add_definitions(
    -DHAVE_BOOST
    -DHAVE_BOOST_UNITS
  )
  message(STATUS "Boost Units have been found.")
else()
  message(
    STATUS
      "Boost Units are an optional feature of length.cc."
      " Ubuntu ships it within the libboost-dev package."
      " You may need to clean up the CMake cache after installing it to pass this check."
  )
endif()

set(int64x64_sources)
set(int64x64_headers)

if(${NS3_INT64X64}
   MATCHES
   "INT128"
)
  set(int64x64_sources
      model/int64x64-128.cc
  )
  set(int64x64_headers
      model/int64x64-128.h
  )
elseif(
  ${NS3_INT64X64}
  MATCHES
  "DOUBLE"
)
  set(int64x64_headers
      model/int64x64-double.h
  )
elseif(
  ${NS3_INT64X64}
  MATCHES
  "CAIRO"
)
  set(int64x64_sources
      model/int64x64-cairo.cc
  )
  set(int64x64_headers
      model/int64x64-cairo.h
      model/cairo-wideint-private.h
  )
endif()

set(example_as_test_sources)
set(example_as_test_headers)
set(example_as_test_suite)
if(${ENABLE_EXAMPLES})
  set(example_as_test_sources
      model/example-as-test.cc
  )
  set(example_as_test_headers
      model/example-as-test.h
  )
  set(example_as_test_suite
      test/examples-as-tests-test-suite.cc
  )
endif()

# Embedded version support
set(embedded_version_sources)
set(embedded_version_headers)
if(${ENABLE_BUILD_VERSION})
  set(embedded_version_sources
      model/version.cc
  )
  set(embedded_version_headers
      model/version.h
  )
endif()

if(WIN32)
  set(libraries_to_link
      ${libraries_to_link}
      wsock32
      ws2_32
  )
  set(fd-reader-sources
      model/win32-fd-reader.cc
  )
else()
  set(fd-reader-sources
      model/unix-fd-reader.cc
  )
endif()

# Define core lib sources
set(source_files
    ${int64x64_sources}
    ${fd-reader-sources}
    ${example_as_test_sources}
    ${embedded_version_sources}
    helper/csv-reader.cc
    helper/random-variable-stream-helper.cc
    helper/event-garbage-collector.cc
    model/time.cc
    model/event-id.cc
    model/scheduler.cc
    model/list-scheduler.cc
    model/map-scheduler.cc
    model/heap-scheduler.cc
    model/calendar-scheduler.cc
    model/priority-queue-scheduler.cc
    model/event-impl.cc
    model/simulator.cc
    model/simulator-impl.cc
    model/default-simulator-impl.cc
    model/timer.cc
    model/watchdog.cc
    model/synchronizer.cc
    model/make-event.cc
    model/environment-variable.cc
    model/log.cc
    model/breakpoint.cc
    model/type-id.cc
    model/attribute-construction-list.cc
    model/object-base.cc
    model/object.cc
    model/test.cc
    model/random-variable-stream.cc
    model/rng-seed-manager.cc
    model/rng-stream.cc
    model/command-line.cc
    model/attribute.cc
    model/boolean.cc
    model/integer.cc
    model/uinteger.cc
    model/double.cc
    model/int64x64.cc
    model/string.cc
    model/pointer.cc
    model/object-ptr-container.cc
    model/object-factory.cc
    model/global-value.cc
    model/trace-source-accessor.cc
    model/config.cc
    model/callback.cc
    model/names.cc
    model/vector.cc
    model/fatal-impl.cc
    model/system-path.cc
    model/hash-function.cc
    model/hash-murmur3.cc
    model/hash-fnv.cc
    model/hash.cc
    model/des-metrics.cc
    model/ascii-file.cc
    model/node-printer.cc
    model/show-progress.cc
    model/time-printer.cc
    model/system-wall-clock-ms.cc
    model/system-wall-clock-timestamp.cc
    model/length.cc
    model/trickle-timer.cc
    model/realtime-simulator-impl.cc
    model/wall-clock-synchronizer.cc
    model/matrix-array.cc
)

# Define core lib headers
set(header_files
    ${int64x64_headers}
    ${example_as_test_headers}
    ${embedded_version_headers}
    helper/csv-reader.h
    helper/event-garbage-collector.h
    helper/random-variable-stream-helper.h
    model/abort.h
    model/ascii-file.h
    model/ascii-test.h
    model/assert.h
    model/attribute-accessor-helper.h
    model/attribute-construction-list.h
    model/attribute-container.h
    model/attribute-helper.h
    model/attribute.h
    model/boolean.h
    model/breakpoint.h
    model/build-profile.h
    model/calendar-scheduler.h
    model/callback.h
    model/command-line.h
    model/config.h
    model/default-deleter.h
    model/default-simulator-impl.h
    model/deprecated.h
    model/des-metrics.h
    model/double.h
    model/enum.h
    model/event-id.h
    model/event-impl.h
    model/fatal-error.h
    model/fatal-impl.h
    model/fd-reader.h
    model/environment-variable.h
    model/global-value.h
    model/hash-fnv.h
    model/hash-function.h
    model/hash-murmur3.h
    model/hash.h
    model/heap-scheduler.h
    model/int-to-type.h
    model/int64x64-double.h
    model/int64x64.h
    model/integer.h
    model/length.h
    model/list-scheduler.h
    model/log-macros-disabled.h
    model/log-macros-enabled.h
    model/log.h
    model/make-event.h
    model/map-scheduler.h
    model/math.h
    model/names.h
    model/node-printer.h
    model/nstime.h
    model/object-base.h
    model/object-factory.h
    model/object-map.h
    model/object-ptr-container.h
    model/object-vector.h
    model/object.h
    model/pair.h
    model/pointer.h
    model/priority-queue-scheduler.h
    model/ptr.h
    model/random-variable-stream.h
    model/rng-seed-manager.h
    model/rng-stream.h
    model/scheduler.h
    model/show-progress.h
    model/simple-ref-count.h
    model/simulation-singleton.h
    model/simulator-impl.h
    model/simulator.h
    model/singleton.h
    model/string.h
    model/synchronizer.h
    model/system-path.h
    model/system-wall-clock-ms.h
    model/system-wall-clock-timestamp.h
    model/test.h
    model/time-printer.h
    model/timer-impl.h
    model/timer.h
    model/trace-source-accessor.h
    model/traced-callback.h
    model/traced-value.h
    model/trickle-timer.h
    model/tuple.h
    model/type-id.h
    model/type-name.h
    model/type-traits.h
    model/uinteger.h
    model/uniform-random-bit-generator.h
    model/valgrind.h
    model/vector.h
    model/warnings.h
    model/watchdog.h
    model/realtime-simulator-impl.h
    model/wall-clock-synchronizer.h
    model/val-array.h
    model/matrix-array.h
)

set(test_sources
    ${example_as_test_suite}
    ${gsl_test_sources}
    test/attribute-container-test-suite.cc
    test/attribute-test-suite.cc
    test/build-profile-test-suite.cc
    test/callback-test-suite.cc
    test/command-line-test-suite.cc
    test/config-test-suite.cc
    test/environment-variable-test-suite.cc
    test/event-garbage-collector-test-suite.cc
    test/global-value-test-suite.cc
    test/hash-test-suite.cc
    test/int64x64-test-suite.cc
    test/length-test-suite.cc
    test/many-uniform-random-variables-one-get-value-call-test-suite.cc
    test/names-test-suite.cc
    test/object-test-suite.cc
    test/one-uniform-random-variable-many-get-value-calls-test-suite.cc
    test/pair-value-test-suite.cc
    test/ptr-test-suite.cc
    test/sample-test-suite.cc
    test/simulator-test-suite.cc
    test/splitstring-test-suite.cc
    test/threaded-test-suite.cc
    test/time-test-suite.cc
    test/timer-test-suite.cc
    test/traced-callback-test-suite.cc
    test/trickle-timer-test-suite.cc
    test/tuple-value-test-suite.cc
    test/type-id-test-suite.cc
    test/type-traits-test-suite.cc
    test/watchdog-test-suite.cc
    test/val-array-test-suite.cc
    test/matrix-array-test-suite.cc
)

# Build core lib
build_lib(
  LIBNAME core
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK ${libraries_to_link}
  TEST_SOURCES ${test_sources}
)

=== ns-3.41/src/mobility/CMakeLists.txt ===
build_lib(
  LIBNAME mobility
  SOURCE_FILES
    helper/group-mobility-helper.cc
    helper/mobility-helper.cc
    helper/ns2-mobility-helper.cc
    model/box.cc
    model/constant-acceleration-mobility-model.cc
    model/constant-position-mobility-model.cc
    model/constant-velocity-helper.cc
    model/constant-velocity-mobility-model.cc
    model/gauss-markov-mobility-model.cc
    model/geographic-positions.cc
    model/hierarchical-mobility-model.cc
    model/mobility-model.cc
    model/position-allocator.cc
    model/random-direction-2d-mobility-model.cc
    model/random-walk-2d-mobility-model.cc
    model/random-waypoint-mobility-model.cc
    model/rectangle.cc
    model/steady-state-random-waypoint-mobility-model.cc
    model/waypoint-mobility-model.cc
    model/waypoint.cc
  HEADER_FILES
    helper/group-mobility-helper.h
    helper/mobility-helper.h
    helper/ns2-mobility-helper.h
    model/box.h
    model/constant-acceleration-mobility-model.h
    model/constant-position-mobility-model.h
    model/constant-velocity-helper.h
    model/constant-velocity-mobility-model.h
    model/gauss-markov-mobility-model.h
    model/geographic-positions.h
    model/hierarchical-mobility-model.h
    model/mobility-model.h
    model/position-allocator.h
    model/random-direction-2d-mobility-model.h
    model/random-walk-2d-mobility-model.h
    model/random-waypoint-mobility-model.h
    model/rectangle.h
    model/steady-state-random-waypoint-mobility-model.h
    model/waypoint-mobility-model.h
    model/waypoint.h
  LIBRARIES_TO_LINK ${libnetwork}
  TEST_SOURCES
    test/box-line-intersection-test.cc
    test/geo-to-cartesian-test.cc
    test/mobility-test-suite.cc
    test/mobility-trace-test-suite.cc
    test/ns2-mobility-helper-test-suite.cc
    test/rand-cart-around-geo-test.cc
    test/rectangle-closest-border-test.cc
    test/steady-state-random-waypoint-mobility-model-test.cc
    test/waypoint-mobility-model-test.cc
)

=== ns-3.41/src/network/CMakeLists.txt ===
set(source_files
    helper/application-container.cc
    helper/delay-jitter-estimation.cc
    helper/net-device-container.cc
    helper/node-container.cc
    helper/packet-socket-helper.cc
    helper/simple-net-device-helper.cc
    helper/trace-helper.cc
    model/address.cc
    model/application.cc
    model/buffer.cc
    model/byte-tag-list.cc
    model/channel-list.cc
    model/channel.cc
    model/chunk.cc
    model/header.cc
    model/net-device.cc
    model/nix-vector.cc
    model/node-list.cc
    model/node.cc
    model/packet-metadata.cc
    model/packet-tag-list.cc
    model/packet.cc
    model/socket-factory.cc
    model/socket.cc
    model/tag-buffer.cc
    model/tag.cc
    model/trailer.cc
    utils/address-utils.cc
    utils/bit-deserializer.cc
    utils/bit-serializer.cc
    utils/crc32.cc
    utils/data-rate.cc
    utils/drop-tail-queue.cc
    utils/dynamic-queue-limits.cc
    utils/error-channel.cc
    utils/error-model.cc
    utils/ethernet-header.cc
    utils/ethernet-trailer.cc
    utils/flow-id-tag.cc
    utils/inet-socket-address.cc
    utils/inet6-socket-address.cc
    utils/ipv4-address.cc
    utils/ipv6-address.cc
    utils/llc-snap-header.cc
    utils/mac16-address.cc
    utils/mac48-address.cc
    utils/mac64-address.cc
    utils/mac8-address.cc
    utils/net-device-queue-interface.cc
    utils/output-stream-wrapper.cc
    utils/packet-burst.cc
    utils/packet-data-calculators.cc
    utils/packet-probe.cc
    utils/packet-socket-address.cc
    utils/packet-socket-client.cc
    utils/packet-socket-factory.cc
    utils/packet-socket-server.cc
    utils/packet-socket.cc
    utils/packetbb.cc
    utils/pcap-file-wrapper.cc
    utils/pcap-file.cc
    utils/queue-item.cc
    utils/queue-limits.cc
    utils/queue-size.cc
    utils/queue.cc
    utils/radiotap-header.cc
    utils/simple-channel.cc
    utils/simple-net-device.cc
    utils/sll-header.cc
    utils/timestamp-tag.cc
)

set(header_files
    helper/application-container.h
    helper/delay-jitter-estimation.h
    helper/net-device-container.h
    helper/node-container.h
    helper/packet-socket-helper.h
    helper/simple-net-device-helper.h
    helper/trace-helper.h
    model/address.h
    model/application.h
    model/buffer.h
    model/byte-tag-list.h
    model/channel-list.h
    model/channel.h
    model/chunk.h
    model/header.h
    model/net-device.h
    model/nix-vector.h
    model/node-list.h
    model/node.h
    model/packet-metadata.h
    model/packet-tag-list.h
    model/packet.h
    model/socket-factory.h
    model/socket.h
    model/tag-buffer.h
    model/tag.h
    model/trailer.h
    test/header-serialization-test.h
    utils/address-utils.h
    utils/bit-deserializer.h
    utils/bit-serializer.h
    utils/crc32.h
    utils/data-rate.h
    utils/drop-tail-queue.h
    utils/dynamic-queue-limits.h
    utils/error-channel.h
    utils/error-model.h
    utils/ethernet-header.h
    utils/ethernet-trailer.h
    utils/flow-id-tag.h
    utils/generic-phy.h
    utils/inet-socket-address.h
    utils/inet6-socket-address.h
    utils/ipv4-address.h
    utils/ipv6-address.h
    utils/llc-snap-header.h
    utils/lollipop-counter.h
    utils/mac16-address.h
    utils/mac48-address.h
    utils/mac64-address.h
    utils/mac8-address.h
    utils/net-device-queue-interface.h
    utils/output-stream-wrapper.h
    utils/packet-burst.h
    utils/packet-data-calculators.h
    utils/packet-probe.h
    utils/packet-socket-address.h
    utils/packet-socket-client.h
    utils/packet-socket-factory.h
    utils/packet-socket-server.h
    utils/packet-socket.h
    utils/packetbb.h
    utils/pcap-file-wrapper.h
    utils/pcap-file.h
    utils/pcap-test.h
    utils/queue-fwd.h
    utils/queue-item.h
    utils/queue-limits.h
    utils/queue-size.h
    utils/queue.h
    utils/radiotap-header.h
    utils/sequence-number.h
    utils/simple-channel.h
    utils/simple-net-device.h
    utils/sll-header.h
    utils/timestamp-tag.h
)

build_lib(
  LIBNAME network
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK ${libstats}
  TEST_SOURCES
    test/bit-serializer-test.cc
    test/buffer-test.cc
    test/drop-tail-queue-test-suite.cc
    test/error-model-test-suite.cc
    test/ipv6-address-test-suite.cc
    test/lollipop-counter-test.cc
    test/packet-metadata-test.cc
    test/packet-socket-apps-test-suite.cc
    test/packet-test-suite.cc
    test/packetbb-test-suite.cc
    test/pcap-file-test-suite.cc
    test/sequence-number-test-suite.cc
    test/test-data-rate.cc
)

=== ns-3.41/src/propagation/CMakeLists.txt ===
build_lib(
  LIBNAME propagation
  SOURCE_FILES
    model/channel-condition-model.cc
    model/cost231-propagation-loss-model.cc
    model/itu-r-1411-los-propagation-loss-model.cc
    model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.cc
    model/jakes-process.cc
    model/jakes-propagation-loss-model.cc
    model/kun-2600-mhz-propagation-loss-model.cc
    model/okumura-hata-propagation-loss-model.cc
    model/probabilistic-v2v-channel-condition-model.cc
    model/propagation-delay-model.cc
    model/propagation-loss-model.cc
    model/three-gpp-propagation-loss-model.cc
    model/three-gpp-v2v-propagation-loss-model.cc
  HEADER_FILES
    model/channel-condition-model.h
    model/cost231-propagation-loss-model.h
    model/itu-r-1411-los-propagation-loss-model.h
    model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h
    model/jakes-process.h
    model/jakes-propagation-loss-model.h
    model/kun-2600-mhz-propagation-loss-model.h
    model/okumura-hata-propagation-loss-model.h
    model/probabilistic-v2v-channel-condition-model.h
    model/propagation-cache.h
    model/propagation-delay-model.h
    model/propagation-environment.h
    model/propagation-loss-model.h
    model/three-gpp-propagation-loss-model.h
    model/three-gpp-v2v-propagation-loss-model.h
  LIBRARIES_TO_LINK ${libmobility}
  TEST_SOURCES
    test/channel-condition-model-test-suite.cc
    test/itu-r-1411-los-test-suite.cc
    test/itu-r-1411-nlos-over-rooftop-test-suite.cc
    test/kun-2600-mhz-test-suite.cc
    test/okumura-hata-test-suite.cc
    test/probabilistic-v2v-channel-condition-model-test.cc
    test/propagation-loss-model-test-suite.cc
    test/three-gpp-propagation-loss-model-test-suite.cc
    test/three-gpp-propagation-loss-model-test-suite.cc
)

=== debian/changelog ===
ns3 (3.41-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:16:40 +0000

ns3 (3.41-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064633

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 14:09:17 +0000

ns3 (3.41-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Sun, 11 Feb 2024 15:40:35 +0100

ns3 (3.40-2) unstable; urgency=medium

  * New patch to fix a FTBFS with sphinx 7.2 (Fix: #1042642).
    Thanks to s3v for the patch.

 -- Martin Quinson <mquinson@debian.org>  Tue, 07 Nov 2023 01:16:50 +0100

ns3 (3.40-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Sat, 04 Nov 2023 00:07:24 +0100

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.6.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: YunQiang Su <syq@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), dpkg-dev (>= 1.22.5),
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-exec (>= 0.13),
 dh-python,
 dpkg (>= 1.16.1),
 flex,
 jdupes,
 libboost-filesystem-dev,
 libgsl-dev,
 libsqlite3-dev,
 libxml2-dev,
 pkg-config,
 python3-dev,
 gir1.2-goocanvas-2.0,
 python3-gi,
 python3-gi-cairo,
 python3-pygraphviz,
 gir1.2-gtk-3.0,
Build-Depends-Indep:
 libgraphviz-dev,
 quilt (>= 0.46-7~),
 ipython3,
 dia,
 doxygen,
 dvipng,
 ghostscript,
 imagemagick,
 latexmk,
 python3-sphinx,
 tex-gyre,
 texlive-font-utils,
 texlive-latex-extra,
 texlive-latex-base,
 texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: https://www.nsnam.org/
Vcs-Git: https://salsa.debian.org/debian/ns3.git

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python3-ns3.

Package: ns3-doc
Architecture: all
Build-Profiles: <!nodoc>
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery, libjs-sphinxdoc
Section: doc
Description: documentation for ns3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains manual, modules, tutorial and doxygen.

# Note to self: when updating this, you also need to update the SONAME in the relevant patch
Package: libns3.41t64
Provides: ${t64:Provides}
Replaces: libns3.41
Breaks: libns3.41 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains shared libraries.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libns3.41t64 (= ${binary:Version}),
  g++,
Breaks: ns3 (= 3.25+dfsg2-2)
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains static libraries, header files.

#Package: python3-ns3
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
#  python3-pygraphviz
#Section: python
#Suggests: tcpdump
#Breaks: python-ns3
#Description: Python binding of ns3
# ns-3 is a discrete-event network simulator for Internet systems,
# targeted primarily for research and educational use.
# ns-3 is free software, licensed under the GNU GPLv2 license,
# and is publicly available for research, development, and use.
# ns-3 is intended as an eventual replacement for the popular
# ns-2 simulator. The project acronym “nsnam” derives
# historically from the concatenation of ns (network simulator)
# and NAM (network animator).
# .
# This package contains Python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Drop the debug symbols all together on mipsel to avoid OOM causing FTBFS
  export DEB_CFLAGS_MAINT_STRIP=-g
  export DEB_CXXFLAGS_MAINT_STRIP=-g
endif

# Define CFLAGS and friends to harden the build -- must come any addtion to these variables
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Further reduce the memory consumption on mipsel
  LDFLAGS += -Wl,--reduce-memory-overheads -Wl,--no-keep-memory
endif

TOPDIR=$(CURDIR)
NS3_DIR=$(shell ls -d ns-*)
PYBINDGENV_DIR=$(shell ls -d pybindgen-*)

# Build in parallel, unless there is less than 3GiB
MEMORY=$(shell awk '/MemTotal:/{print $$2}' /proc/meminfo)
CPU_CORES=$(shell nproc)
BUILD_OPTION=$(shell if [ $(MEMORY) -lt 3090252 ]; then echo "-j1"; else echo "-j$(CPU_CORES)"; fi)

include /usr/share/dpkg/architecture.mk

# Reproducible Build wants us to use always the same date when building the documentation
include /usr/share/dpkg/pkg-info.mk
SPHINXOPTS := -D today=\"$(SOURCE_DATE_EPOCH)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(SOURCE_DATE_EPOCH)\"

# Include version information
VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+dfsg.*//' | sed -e 's/\+ds.*//')
MAJOR_VERSION=$(word 1,$(subst ., ,$(VERSION)))
MINOR_VERSION=$(word 2,$(subst ., ,$(VERSION)))
PATCH_VERSION=$(word 3,$(subst ., ,$(VERSION).0)) # Add an extra .0 just in case there is no patch level

BUILD_PROFILE=release

%:
	dh $@ --with python3

# Set up version cache to allow generating version module. The double 0 is due to a CMake peculiarity.

execute_before_dh_auto_configure:
	cd $(NS3_DIR) ; \
	sed -e "s/@NS3_VERSION_CLOSEST_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_COMMIT_HASH@//" \
	    -e "s/@NS3_VERSION_DIRTY_FLAG@/1/" \
	    -e "s/@NS3_VERSION_MAJOR@/$(MAJOR_VERSION)/" \
	    -e "s/@NS3_VERSION_MINOR@/$(MINOR_VERSION)/" \
	    -e "s/@NS3_VERSION_PATCH@/$(PATCH_VERSION)/" \
	    -e "s/@NS3_VERSION_RELEASE_CANDIDATE@//" \
	    -e "s/@NS3_VERSION_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_TAG_DISTANCE@/00/" \
	    -e "s/@NS3_VERSION_BUILD_PROFILE@/$(BUILD_PROFILE)/" \
	    build-support/version.cache.in > src/core/model/version.cache

# Use the ns3 wrapper over cmake because I fail to get it work otherwise,
# but pass the parameters that cmake needs to build a proper Debian package (copied from the simgrid build logs)

override_dh_auto_configure:
	cd $(NS3_DIR) ; ./ns3 configure --verbose \
		--build-profile=$(BUILD_PROFILE) --enable-python-bindings --enable-logs --enable-examples --enable-tests --disable-mpi --enable-build-version \
                --prefix=/usr -- \
		-DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON \
		-DCMAKE_INSTALL_RUNSTATEDIR=/run -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DCMAKE_INSTALL_PREFIX=/usr

override_dh_auto_build-arch:
	cd $(NS3_DIR) ; ./ns3 build --verbose

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v sphinx"
	cd $(NS3_DIR) ; export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v sphinx
	echo "XXXX done: ./ns3 docs sphinx"
	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v all "
	cd $(NS3_DIR) ; export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v all
	echo "XXXX done: ./ns3 docs all"
	rm -f ns-3.*/doc/*/build/*/_static/jquery.js
	rm -f ns-3.*/doc/*/build/*/_static/underscore.js
else
	for d in manual models tutorial ; do mkdir -p $(NS3_DIR)/doc/$$d/build/html ; touch $(NS3_DIR)/doc/$$d/build/html/index.html ; done
endif
	touch $@

override_dh_auto_install:
	here=$(CURDIR); cd $(NS3_DIR) ; \
		DESTDIR=$${here}/debian/tmp AM_UPDATE_INFO_DIR=no INSTALL="install --strip-program=true" \
		./ns3 install
	
	mkdir -p debian/tmp/usr/bin
	# cp netanim-*/NetAnim debian/tmp/usr/bin
	# Install my own little script as a compiler
	set -e ;\
	all_libs=$$(find debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ -name 'libns3*.so' | sed -e "s|debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/||" -e 's/.so$$//' | sort) ;\
	sed -e "s/@ALL_LIBS@/$$(echo $$all_libs)/g" debian/ns3++.in > debian/tmp/usr/bin/ns3++
	chmod +x debian/tmp/usr/bin/ns3++
	# Install the upstream changelog as NEWS, as requested by the policy
	(cd ns-3.*; cp RELEASE_NOTES.md NEWS.md)
	
override_dh_auto_test:
	-cd ./$(NS3_DIR); ./test.py -v

override_dh_installchangelogs:
	dh_installchangelogs ./$(NS3_DIR)/CHANGES.md

override_dh_link:
	dh_link
	if test -e debian/ns3-doc/usr/share/doc; then \
		jdupes -rl debian/ns3-doc/usr/share/doc; \
	fi

override_dh_install:
	dh_install
	
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# The doc is not built when building only for a given arch (it's built in 'arch:all')
	if [ -e debian/ns3-doc/usr/share/doc/ns3/manual/html/_static ] ; then \
	  for where in manual models tutorial ; do \
	    for what in doctools.js language_data.js searchtools.js ; do \
	      rm debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
	      ln -s /usr/share/javascript/sphinxdoc/1.0/$${what} debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
	    done ; \
	  done ; \
	fi
endif

override_dh_auto_clean:
	#-sh ./debian/clean-tree.sh
	rm -f src/core/model/version.cache
	dh_auto_clean

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_compress:
	dh_compress -Xusr/share/doc/ns3/examples/  -Xusr/share/doc/ns3/manual/  -Xusr/share/doc/ns3/models/  -Xusr/share/doc/ns3/tutorial/
endif

update-patches:
	cd debian/patches; \
	sed -i 's#ns-3.[0-9]*#$(NS3_DIR)#g' *.diff *.patch
	@echo "Don't forget to update debian/control to rename the lib package,"
	@echo "and the SONAME in the library-soversion.diff patch."
